
## Run file "Initial Commands" first ##

g1<-c("../Inc/agem1.csv", "../Inc/agem2.csv", "../Inc/agem3.csv", "../Inc/agef1.csv", "../Inc/agef2.csv", "../Inc/agef3.csv",
	"../Inc/occm1.csv",  "../Inc/occm3.csv", "../Inc/occm4.csv", "../Inc/occf1.csv",
	"../Inc/occf3.csv", "../Inc/deferm2.csv", "../Inc/deferm3.csv", "../Inc/deferf2.csv", "../Inc/deferf3.csv")

g2<-c("../LogInc/agem1.csv", "../LogInc/agem2.csv", "../LogInc/agem3.csv", "../LogInc/agef1.csv", "../LogInc/agef2.csv", "../LogInc/agef3.csv",
	"../LogInc/occm1.csv", "../LogInc/occm3.csv", "../LogInc/occm4.csv", "../LogInc/occf1.csv", "../LogInc/occf3.csv", "../LogInc/deferm2.csv", 
	"../LogInc/deferm3.csv", "../LogInc/deferf2.csv", "../LogInc/deferf3.csv")

fact<-read.table("../factors.txt", head=TRUE)
fact1<-as.matrix(fact)

result1<-matrix(nrow=30,ncol=2)
result2<-matrix(nrow=15,ncol=5)
result3<-matrix(nrow=15,ncol=5)


for(m in 1:15){
n=m*2-1;o=m*2;

## Hurdle model on original data##
plot1<-matrix(nrow=121,ncol=4)
aub1 <- read.csv(file=paste(g1[m]),head=TRUE,sep=",")
aub2<-subset(aub1,p==1)

attach(aub1)
obs<-dim(aub1)[1]
wgt1<-iexps*obs/sum(iexps)
log1<-glm(p~U0+factor(month)+factor(defn)+factor(amt)+factor(ncb)+factor(cont)+factor(aids),family=binomial, weights=wgt1,data=aub1)
if(names(sort(-table(month)))[1]=="1"){x1<-c(0,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="2"){x1<-c(1,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="3"){x1<-c(0,1,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="4"){x1<-c(0,0,1,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="5"){x1<-c(0,0,0,1,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="6"){x1<-c(0,0,0,0,1,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="7"){x1<-c(0,0,0,0,0,1,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="8"){x1<-c(0,0,0,0,0,0,1,0,0,0,0)}
if(names(sort(-table(month)))[1]=="9"){x1<-c(0,0,0,0,0,0,0,1,0,0,0)}
if(names(sort(-table(month)))[1]=="10"){x1<-c(0,0,0,0,0,0,0,0,1,0,0)}
if(names(sort(-table(month)))[1]=="11"){x1<-c(0,0,0,0,0,0,0,0,0,1,0)}
if(names(sort(-table(month)))[1]=="12"){x1<-c(0,0,0,0,0,0,0,0,0,0,1)}
d1<-shuffle(log1$coef,sqrt(diag(vcov(log1))), c(.05,.01),log1$df.residual, two.sided=T, digits=3, apa=F)
result1[n:o,1]<-d1[3:4,2]
detach(aub1)

attach(aub2)
obs<-dim(aub2)[1]
wgt2<-iexps*obs/sum(iexps)
ae=iabp/iexpt
lmu1<- lm(log(ae)~U0+factor(month)+factor(defn)+factor(amt)+factor(ncb)+factor(cont)+factor(aids), weights=sqrt(wgt2),data=aub2)
s21 <- summary(lmu1)$sigma^2
if(names(sort(-table(month)))[1]=="1"){x2<-c(0,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="2"){x2<-c(1,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="3"){x2<-c(0,1,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="4"){x2<-c(0,0,1,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="5"){x2<-c(0,0,0,1,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="6"){x2<-c(0,0,0,0,1,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="7"){x2<-c(0,0,0,0,0,1,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="8"){x2<-c(0,0,0,0,0,0,1,0,0,0,0)}
if(names(sort(-table(month)))[1]=="9"){x2<-c(0,0,0,0,0,0,0,1,0,0,0)}
if(names(sort(-table(month)))[1]=="10"){x2<-c(0,0,0,0,0,0,0,0,1,0,0)}
if(names(sort(-table(month)))[1]=="11"){x2<-c(0,0,0,0,0,0,0,0,0,1,0)}
if(names(sort(-table(month)))[1]=="12"){x2<-c(0,0,0,0,0,0,0,0,0,0,1)}
d1<-shuffle(lmu1$coef,sqrt(diag(vcov(lmu1))), c(.05,.01),lmu1$df.residual, two.sided=T, digits=3, apa=F)
result1[n:o,2]<-d1[3:4,2]
detach(aub2)

z1<- matrix(nrow=121,ncol=3)
for( i in 31:151){
j=(i-1)/1000
res1<-matrix(nrow=120,ncol=2)

for(k in 1:120){
nxx<-c(1,j,x1,fact1[k,])
nyx<-c(1,j,x2,fact1[k,])
y1<-nxx%*%coef(log1)
y2<-nyx%*%coef(lmu1)
res1[k,1]<-exp(y1)/(1+exp(y1))
res1[k,2]<-exp(y2+s21/2)
}

oa=i-30
z1[oa,1]<-apply(res1,2,mean)[1]
z1[oa,2]<-apply(res1,2,mean)[2]
z1[oa,3]<-z1[oa,1]*z1[oa,2]
}

plot1[,1]<-z1[,1]
plot1[,2]<-z1[,2]
plot1[,3]<-z1[,3]

abc1<-diff(plot1[,3])
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result2[m,1]<-mean(abc3)



## Multi-logit original model ##

aubm1 <- read.csv(file=paste(g2[m]),head=TRUE,sep=",")
aubm2<- aubm1
aubm2$month<-as.factor(aubm2$month)
aubm2$amt<-as.factor(aubm2$amt)
aubm3<-mlogit.data(aubm2,varying=NULL, choice="claim", shape="wide")

model1<-mlogit(claim~1|U0+month+amt+defn+cont+ncb+aids,data=aubm3)

attach(aubm2)
if(names(sort(-table(month)))[1]=="1"){xd1<-c(0,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="2"){xd1<-c(1,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="3"){xd1<-c(0,1,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="4"){xd1<-c(0,0,1,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="5"){xd1<-c(0,0,0,1,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="6"){xd1<-c(0,0,0,0,1,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="7"){xd1<-c(0,0,0,0,0,1,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="8"){xd1<-c(0,0,0,0,0,0,1,0,0,0,0)}
if(names(sort(-table(month)))[1]=="9"){xd1<-c(0,0,0,0,0,0,0,1,0,0,0)}
if(names(sort(-table(month)))[1]=="10"){xd1<-c(0,0,0,0,0,0,0,0,1,0,0)}
if(names(sort(-table(month)))[1]=="11"){xd1<-c(0,0,0,0,0,0,0,0,0,1,0)}
if(names(sort(-table(month)))[1]=="12"){xd1<-c(0,0,0,0,0,0,0,0,0,0,1)}
x1<-xd1
detach(aubm2)

resm1<-NULL
for(i in 31:151){
j=(i-1)/1000
resm2<-NULL
for(k in 1:120){
nxx<-c(1,j,x1,fact1[k,])
calc1<-sum(nxx*model1$coef[seq(1,length(model1$coef),by=3)])
calc2<-sum(nxx*model1$coef[seq(2,length(model1$coef),by=3)])
calc3<-sum(nxx*model1$coef[seq(3,length(model1$coef),by=3)])
calc<-cbind(0,calc1,calc2,calc3)
p.unscaled<-exp(calc)
resm2<-rbind(resm2,p.unscaled / rowSums(p.unscaled))
}
resm1<-rbind(resm1,apply(resm2,2,mean))
}

plotm1<-resm1

abc<-apply(plotm1,2,diff)
abc1<-abc[,1]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result2[m,2]<-mean(abc3)

abc1<-abc[,2]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result2[m,3]<-mean(abc3)

abc1<-abc[,3]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result2[m,4]<-mean(abc3)

abc1<-abc[,4]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result2[m,5]<-mean(abc3)


## Combinined Results Original ##
newplot1<-matrix(nrow=121,ncol=4)
abc1<- vector(length=121)
abc1[1]<-1000

for(j in 2:121){
abc1[j]<-1000+1000*(plot1[j,3]-plot1[1,3])/plot1[1,3]
}
plot1[,4]<-abc1
newplot1[,1]<-abc1*resm1[,1]
newplot1[,2]<-abc1*resm1[,2]
newplot1[,3]<-abc1*resm1[,3]
newplot1[,4]<-abc1*resm1[,4]

abc1<-diff(plot1[,4])
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result3[m,1]<-mean(abc3)

abc<-apply(newplot1,2,diff)
abc1<-abc[,1]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result3[m,2]<-mean(abc3)

abc1<-abc[,2]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result3[m,3]<-mean(abc3)

abc1<-abc[,3]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result3[m,4]<-mean(abc3)

abc1<-abc[,4]
abc2<-matrix(abc1, ncol=12)
abc3<-apply(abc2,2,sum)
result3[m,5]<-mean(abc3)
}

result1 ## Table 4 - Provides coef estimates of the two parts of the conditional model
result2 ## Not Used - % change in A/E and the four causes of claim for 1% change in u-rate
round(result3,digits=1) ## Table 5 - Change in number of claims for 1% change in U-rate (assumes 1000 claims at 3% u-rate)
