

## Combined Model ##

con1<- read.table("../ComOutput/deferf2_plot1.txt",header=T)
con2<- read.table("../ComOutput/deferf3_plot1.txt",header=T)

ur2<-30:150/1000
ur1<-30:150/1000
par(mfrow=c(2,4),oma = c(0,0,4,0))

max1<-max(con1)
min1<-min(con1)

plot1<-con1[,1:3]
plot(ur1,plot1[,1],main= "Accident",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Males",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="blue")
lines(ur2,plot1[,2],lty=4,col="blue")
lines(ur2,plot1[,3],lty=4,col="blue")
abline(h=plot1[1,1])

plot1<-con1[,4:6]
plot(ur1,plot1[,1],main= "Mental Illness",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Males",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="gray")
lines(ur2,plot1[,2],lty=4,col="gray")
lines(ur2,plot1[,3],lty=4,col="gray")
abline(h=plot1[1,1])

plot1<-con1[,7:9]
plot(ur1,plot1[,1],main= "Musculo-Skeletal",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Males",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="red")
lines(ur2,plot1[,2],lty=4,col="red")
lines(ur2,plot1[,3],lty=4,col="red")
abline(h=plot1[1,1])

plot1<-con1[,10:12]
plot(ur1,plot1[,1],main= "All Other",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Males",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="black")
lines(ur2,plot1[,2],lty=4,col="black")
lines(ur2,plot1[,3],lty=4,col="black")
abline(h=plot1[1,1])

max1<-max(con2)
min1<-min(con2)

plot1<-con2[,1:3]
plot(ur1,plot1[,1],main= "Accident",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Females",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="blue")
lines(ur2,plot1[,2],lty=4,col="blue")
lines(ur2,plot1[,3],lty=4,col="blue")
abline(h=plot1[1,1])

plot1<-con2[,4:6]
plot(ur1,plot1[,1],main= "Mental Illness",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Females",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="gray")
lines(ur2,plot1[,2],lty=4,col="gray")
lines(ur2,plot1[,3],lty=4,col="gray")
abline(h=plot1[1,1])

plot1<-con2[,7:9]
plot(ur1,plot1[,1],main= "Musculo-Skeletal",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Females",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="red")
lines(ur2,plot1[,2],lty=4,col="red")
lines(ur2,plot1[,3],lty=4,col="red")
abline(h=plot1[1,1])

plot1<-con2[,10:12]
plot(ur1,plot1[,1],main= "All Other",xlab="Unemployment Rate", ylab="Number of Claims", type="n",sub="Females",ylim=c(min1,max1))
lines(ur1,plot1[,1],lty=1,col="black")
lines(ur2,plot1[,2],lty=4,col="black")
lines(ur2,plot1[,3],lty=4,col="black")
abline(h=plot1[1,1])

